VERSION 5.00
Begin VB.Form frmWorkDlg 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Searching"
   ClientHeight    =   2355
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2760
   Icon            =   "FWorkDlg.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2355
   ScaleWidth      =   2760
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   255
      Left            =   120
      ScaleHeight     =   195
      ScaleWidth      =   2475
      TabIndex        =   2
      Top             =   1380
      Visible         =   0   'False
      Width           =   2535
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   435
      Left            =   600
      TabIndex        =   0
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Image Image2 
      Height          =   480
      Left            =   780
      Picture         =   "FWorkDlg.frx":0442
      Top             =   180
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   120
      Picture         =   "FWorkDlg.frx":074C
      Top             =   180
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Label2"
      Height          =   195
      Left            =   180
      TabIndex        =   3
      Top             =   1380
      Width           =   2355
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Label1"
      Height          =   195
      Left            =   180
      TabIndex        =   1
      Top             =   1080
      Width           =   2355
   End
End
Attribute VB_Name = "frmWorkDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ********************************************
' Copyright Karl E. Peterson, 1997
' All Rights Reserved.
' ********************************************
' Written for publication in January 1998,
' Visual Basic Programmer's Journal.
' May be freely used in your applications.
' Redistribution of source prohibited.
' ********************************************
Option Explicit

Private Anim As CAnimateEx
Private pBar As CProgressBar
Private m_Caption1 As String
Private m_Caption2 As String
Private m_Resource As Long
Private m_Title As String
Private m_Owner As Long
Private m_ShowProg As Boolean
Private m_Loaded As Boolean

Public Event Cancel()

' ***********************************************
'  Public Properties
' ***********************************************
Public Property Let Caption1(ByVal NewVal As String)
   m_Caption1 = NewVal
   If m_Loaded Then Label1.Caption = m_Caption1
End Property

Public Property Get Caption1() As String
   Caption1 = m_Caption1
End Property

Public Property Let Caption2(ByVal NewVal As String)
   m_Caption2 = NewVal
   If m_Loaded Then Label2.Caption = m_Caption2
End Property

Public Property Get Caption2() As String
   Caption2 = m_Caption2
End Property

Public Property Let Title(ByVal NewVal As String)
   m_Title = NewVal
   If m_Loaded Then Me.Caption = m_Title
End Property

Public Property Get Title() As String
   Title = m_Title
End Property

Public Property Let Mode(ByVal NewVal As Long)
   m_Resource = NewVal
   If m_Loaded Then Anim.ResourceID = m_Resource
End Property

Public Property Get Mode() As Long
   Mode = m_Resource
End Property

Public Property Let Percent(ByVal NewVal As Long)
   If Not pBar Is Nothing Then
      pBar.Value = NewVal
   End If
End Property

Public Property Get Percent() As Long
   If Not pBar Is Nothing Then
      Percent = pBar.Value
   Else
      Percent = 0
   End If
End Property

Public Property Let Owner(ByVal NewVal As Long)
   m_Owner = NewVal
End Property

Public Property Get Owner() As Long
   Owner = m_Owner
End Property

Public Property Let ShowProgress(ByVal NewVal As Boolean)
   ' this property should be set before loading form
   m_ShowProg = NewVal
End Property

Public Property Get ShowProgress() As Boolean
   ShowProgress = m_ShowProg
End Property

' ***********************************************
'  Private Form Events
' ***********************************************
Private Sub cmdCancel_Click()
   RaiseEvent Cancel
End Sub

Private Sub Form_Initialize()
   ' initialize some variables
   m_Title = "Working"
   m_Caption1 = ""
   m_Caption2 = ""
   m_Resource = aviSearch
   m_Owner = 0
   m_ShowProg = False
   m_Loaded = False
End Sub

Private Sub Form_Load()
   ' adjust controls
   Label1.Caption = m_Caption1
   Label2.Caption = m_Caption2
   Label1.Move 0, Label1.Top, Me.ScaleWidth
   cmdCancel.Left = (Me.ScaleWidth - cmdCancel.Width) \ 2
   Me.Caption = m_Title
   Me.Icon = Image1.Picture
   
   ' setup progress bar
   If m_ShowProg Then
      Set pBar = New CProgressBar
      Set pBar.Client = Picture1
      pBar.ResizeEx
      Picture1.Left = (Me.ScaleWidth - Picture1.Width) \ 2
      Picture1.Visible = True
      Label2.Visible = False
   Else
      Label2.Move 0, Label2.Top, Me.ScaleWidth
      Label2.Visible = True
      Picture1.Visible = False
   End If
   
   ' setup animateion
   Me.ScaleMode = vbPixels
   Set Anim = New CAnimateEx
   With Anim
      .AutoPlay = True
      .Center = False
      .Parent = Me.hwnd
      Select Case m_Resource
         Case aviSearch       '80w by 50h
            .Move (Me.ScaleWidth \ 2) - 40, 20, 0, 0
         Case aviFindComputer '48w by 45h
            .Move (Me.ScaleWidth \ 2) - 24, 25, 0, 0
         Case aviPrinting     '32w by 30h
            .Move (Me.ScaleWidth \ 2) - 16, 25, 0, 0
            Me.Icon = Image2.Picture
      End Select
      .ResourceID = m_Resource
   End With
   
   ' position form
   Call Position
   
   ' signal that we're loaded
   m_Loaded = True
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
   If UnloadMode = vbFormControlMenu Then
      Cancel = True
      Call cmdCancel_Click
   End If
End Sub

' ***********************************************
'  Private Methods
' ***********************************************
Private Sub Position()
   If m_Owner = 0 Then
      Me.Move (Screen.Width - Me.Width) \ 2, (Screen.Height - Me.Height) \ 2
   Else
      Call CenterOver(Me.hwnd, m_Owner)
   End If
End Sub
