VERSION 4.00
Begin VB.Form frmAniTest 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "File Download"
   ClientHeight    =   2040
   ClientLeft      =   1275
   ClientTop       =   1545
   ClientWidth     =   5535
   Height          =   2445
   Icon            =   "FAnimVb4.frx":0000
   Left            =   1215
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2040
   ScaleWidth      =   5535
   ShowInTaskbar   =   0   'False
   Top             =   1200
   Width           =   5655
   Begin VB.PictureBox Picture1 
      Height          =   255
      Left            =   120
      ScaleHeight     =   195
      ScaleWidth      =   3975
      TabIndex        =   4
      Top             =   1440
      Width           =   4035
   End
   Begin VB.Timer Timer1 
      Interval        =   250
      Left            =   4980
      Top             =   1020
   End
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   345
      Left            =   4320
      TabIndex        =   0
      Top             =   1560
      Width           =   1080
   End
   Begin MsghookLib.Msghook MsgHook 
      Left            =   4920
      Top             =   360
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Estimated Time Left:  "
      Height          =   195
      Left            =   135
      TabIndex        =   3
      Tag             =   "Estimated Time Left:  "
      Top             =   1770
      Width           =   1530
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "file123.zip from ftp://ftp.yoohoo.com"
      Height          =   195
      Left            =   135
      TabIndex        =   2
      Tag             =   "file123.zip from ftp://ftp.yoohoo.com"
      Top             =   1170
      Width           =   2565
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Opening:"
      Height          =   195
      Left            =   135
      TabIndex        =   1
      Top             =   930
      Width           =   645
   End
End
Attribute VB_Name = "frmAniTest"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private pBar As CProgressBar
Private Animate As CAnimate
Private Const AviFileComp As Long = 101
Private Const AviSearch As Long = 102
Private Const AviFileCopy As Long = 103
Private Const AviDownload As Long = 104

Private Const WM_CTLCOLORSTATIC = &H138
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Sub Command1_Click()
   Unload Me
End Sub

Private Sub Form_Click()
   Static FromResource As Boolean
   Call LoadAvi(FromResource)
   FromResource = Not FromResource
End Sub

Private Sub Form_Load()
   Msghook.HwndHook = Me.hWnd
   Msghook.Message(WM_CTLCOLORSTATIC) = True

   Set Animate = New CAnimate
   With Animate
      .Parent = Me.hWnd
      .Move 15, 10, 300, 50
      .AutoPlay = True
      .Center = False
      .Transparent = True
      Call LoadAvi(FromFile:=True)
   End With
   
   Set pBar = New CProgressBar
   Set pBar.Client = Picture1
   pBar.ResizeEx
    
   Me.Show
   Me.Refresh
End Sub

Private Sub LoadAvi(Optional ByVal FromFile)
   If IsMissing(FromFile) Then FromFile = False
   If FromFile Then
      If Dir(App.Path & "\Download.AVI") = "" Then
         MsgBox "Unable to find AVI"
      Else
         Animate.FileName = App.Path & "\Download.AVI"
      End If
   Else
      Animate.ResourceID = AviDownload
   End If
   Me.Refresh
End Sub

Private Sub MsgHook_Message(ByVal msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
   result = Msghook.InvokeWindowProc(msg, lp, wp)
   If msg = WM_CTLCOLORSTATIC Then
      If lp = Animate.hWnd Then
         Call SetBkColor(wp, CheckSysColor(Me.BackColor))
      End If
   End If
End Sub

Private Sub Timer1_Timer()
   Static Downloaded As Long
   Dim percent As Single
   Dim msg As String
   Dim m As Long, s As Long
   Const Duration = 480000 '480K
   
   Downloaded = Downloaded + 1000 '4 kbps
   If Downloaded < Duration Then
      percent = Downloaded / Duration
      If Int(percent * 100) > pBar.Value Then
         pBar.Value = Int(percent * 100)
         s = (Duration - Downloaded) \ 4000
         If s >= 60 Then
            m = s / 60
            s = s Mod 60
            msg = m & " min " & s & " sec"
         Else
            msg = s & " sec"
         End If
         Label3.Caption = Label3.Tag & msg
         Label2.Caption = Label2.Tag & " (" & Downloaded / 1000 & "K)"
      End If
   Else
      Unload Me
   End If
End Sub

Private Function CheckSysColor(ByVal Color As Long) As Long
   Const HighBit = &H80000000
   '
   ' If high bit set, strip, and get system color.
   '
   If Color And HighBit Then
      CheckSysColor = GetSysColor(Color And Not HighBit)
   Else
      CheckSysColor = Color
   End If
End Function

